float4x4 ViewProjection;

struct VertexShaderInput
{
    float4 Position : POSITION;
};

struct VertexShaderOutput
{
    float4 Position : POSITION0;
    float4 ProjectedPosition : TEXCOORD0;
};

VertexShaderOutput instanced_vs(VertexShaderInput input, float3 Translation : TEXCOORD2)
{
    VertexShaderOutput output;
    
    float4x4 world = float4x4(
        float4(1, 0, 0, 0),
        float4(0, 1, 0, 0),
        float4(0, 0, 1, 0),
        float4(Translation.x, Translation.y, Translation.z, 1)
        );

    float4x4 worldViewProjection = mul(world, ViewProjection);

    output.Position = mul(input.Position, worldViewProjection);
    output.ProjectedPosition = output.Position;

    return output;
}

float4 main_ps(VertexShaderOutput input) : COLOR0
{
    return float4(input.ProjectedPosition.z / input.ProjectedPosition.w, 0.0, 0.0, 0.0);
}

Technique SimpleDepth
{
    Pass
    {
        VertexShader = compile vs_3_0 instanced_vs();
        PixelShader  = compile ps_3_0 main_ps();
    }
}
